#include<stdio.h>
#include<math.h>

int main(){

  FILE *fp;
  double x;

  /* 後ろで定義するsin(x)をx=0でテーラー展開してn次まで計算する関数 */
  double sintaylor(double,int);

  /* 結果を出力するファイルを開く */
  fp=fopen("sinx.dat", "w");

  /* xが-10から0.1刻みで10まで */
  for(x=-10.0; x<10.0; x+=0.1){

    /* x, sin(x),とそのテーラー展開11次までをファイルに出力 */
    fprintf(fp, "%f %f %f %f %f %f %f %f\n", x, sin(x), sintaylor(x,1), sintaylor(x,3), sintaylor(x,5), sintaylor(x,7), sintaylor(x,9), sintaylor(x,11));
    
  }
  
  return 0;

}

/* sin(x)をx=0でテーラー展開してn次まで計算する関数 */
double sintaylor(double x, int n){
  int k, sgn;
  double taylor = 0.0; // 初期値を代入
  double factorial(int); // 後ろで定義されている階乗を計算する関数
  
  sgn=1;

  /* 展開の次数のループ */
  for(k=1; k<=n; k+=2){

    /* k次の展開項を足す */
    taylor += sgn * pow(x,k)/factorial(k);

    /* 符号は毎回変わるので次の次数計算のために(-1)をかける */
    sgn *= -1;
      
  }

  /* taylorの値を返す */
  return(taylor);

}

/* 階乗を計算する関数 */
double factorial(int n){
  int k;
  double fact = 0.0;
  
  if(n<0) return(fact);

  fact = 1.0;
  if(n==0) return(fact);

  for(k=1;k<=n; k++){

    fact *= (double) k;
    
  }

  return(fact);

}
